#
# spec file for package ddd
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           ddd
BuildRequires:  ImageMagick
BuildRequires:  apache2-devel
BuildRequires:  freetype2-devel
BuildRequires:  gcc-c++
BuildRequires:  ghostscript-library
BuildRequires:  ghostscript_any
BuildRequires:  libapr-util1-devel
BuildRequires:  libtiff-devel
BuildRequires:  ncurses-devel
# configure switch --without-motif is not designated to work
# (you'll get 'don't use --without-motif' in configure time)
BuildRequires:  makeinfo
BuildRequires:  openmotif-devel
BuildRequires:  pcre-devel
BuildRequires:  transfig
BuildRequires:  update-desktop-files
BuildRequires:  xorg-x11
Requires:       gdb
Version:        3.3.12
Release:        6.37
Summary:        Debugger with Graphical User Interface
License:        GPL-2.0+ and LGPL-2.1+
Group:          Development/Tools/Debuggers
Url:            http://www.gnu.org/software/ddd
Source:         ddd-%{version}.tar.bz2
Source1:        ddd.png
Source2:        ddd.desktop
Source3:        README.SUSE
Source4:        ddd.wrapper
Patch0:         ddd-3.3.12-gcc44.patch
Patch1:         ddd-wrong-memcpy.patch
Patch2:         ddd-texinfo-5.0.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         %install_info_prereq
# NOTE: We don't want this dependency and desktop-data-SuSE is in all
# desktop selections.
#Requires:    desktop-data-SuSE

%description
The DDD debugger (Data Display Debugger) is a comfortable GUI to the
well-known debuggers GDB and DBX. Data structures can be represented as
graphs and shown interactively. Programs can be debugged in C, C++,
Pascal, MODULA-2, FORTRAN, ADA, and even at the assembler code level.

%package doc
Summary:        Debugger with Graphical User Interface
Group:          Development/Tools/Debuggers
%if %suse_version > 1110
BuildArch:      noarch
%endif

%description doc
The DDD debugger (Data Display Debugger) is a comfortable GUI to the
well-known debuggers GDB and DBX. Data structures can be represented as
graphs and shown interactively. Programs can be debugged in C, C++,
Pascal, MODULA-2, FORTRAN, ADA, and even at the assembler code level.

%prep
%define apache_docroot %(apxs2 -q PREFIX)/htdocs
%setup -q
%patch0
%patch1 -p1
%patch2 -p1

%build
cp %{S:3} .
%if %suse_version > 1210
%configure --with-termlib=tinfo
%else
%configure
%endif
make %{?_smp_mflags} all 
make html

%install
%makeinstall
mkdir -p  $RPM_BUILD_ROOT/usr/share/X11/app-defaults/
install -m 644 ddd/Ddd $RPM_BUILD_ROOT/usr/share/X11/app-defaults/
install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/packages/%{name}/
mkdir -p doc/html/PICS
cp -a ddd/PICS/*.jpg doc/html/PICS
cp -a ddd/style.css doc/html
mkdir -p $RPM_BUILD_ROOT/usr/share/pixmaps
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/usr/share/pixmaps/
mkdir -p $RPM_BUILD_ROOT/usr/share/applications
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/usr/share/applications/
mv $RPM_BUILD_ROOT/usr/bin/ddd $RPM_BUILD_ROOT/usr/bin/ddd.org
install %{SOURCE4} $RPM_BUILD_ROOT/usr/bin/ddd
%suse_update_desktop_file ddd

%post
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/ddd-themes.info.gz

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/ddd-themes.info.gz

%files
%defattr(-, root, root)
%doc AUTHORS COPYING INSTALL NEWS README TIPS TODO README.SUSE
%config /usr/share/X11/app-defaults/Ddd
%attr(755, root, root) /usr/bin/ddd.org
%attr(755, root, root) /usr/bin/ddd
%{_mandir}/man1/ddd.*
%{_infodir}/ddd*
/usr/share/ddd-%{version}/ 
/usr/share/applications/ddd.desktop
/usr/share/pixmaps/ddd.png
%exclude /usr/share/ddd-%{version}/NEWS
%exclude /usr/share/ddd-%{version}/COPYING
%exclude /usr/share/ddd-%{version}/ddd/Ddd

%files doc
%defattr(-,root,root,-)
%doc doc/ddd-paper.ps doc/*.pdf doc/html

%changelog
* Tue Feb 24 2015 dimstar@opensuse.org
- Add ddd-texinfo-5.0.patch: Fix HTML generation with texinfo 5.0.
* Sun Oct 19 2014 Led <ledest@gmail.com>
- fix shebang of ddd.wrapper
* Sat Jul 20 2013 coolo@suse.com
- fix license to be in spdx.org format
* Sun Feb  3 2013 lnt-sysadmin@lists.lrz.de
- added makeinfo to BuildRequires
* Tue Feb 21 2012 pgajdos@suse.com
- buildrequire xorg-x11
* Tue Dec 27 2011 idonmez@suse.com
- Fix wrong size parameter in memcpy call
* Tue Nov 22 2011 pgajdos@suse.com
- compile against libtinfo
* Tue Nov 15 2011 pgajdos@suse.com
- don't build html in parallel build
* Sun Sep 18 2011 jengelh@medozas.de
- Remove redundant tags/sections from specfile
  (cf. packaging guidelines)
- Use %%_smp_mflags for parallel build
* Mon Sep  7 2009 aj@suse.de
- Build doc subpackage as noarch to save 6 MB on media.
* Thu Feb 26 2009 crrodriguez@suse.de
- fix build with GCC44
* Fri Feb 20 2009 mseben@suse.cz
- updated to 3.3.12
  - Consolidated support for pydb, bashdb and remake.
- changes in 3.3.12-rc2
  - DDD can once more locate its own core file when it crashes, even on
  Linux systems where the core file may not be named "core".
- changes in 3.3.12-rc1
  - Fixed several segmentation faults.
  - Fixed a few regressions affecting gdb support after merging the pydb
    code.
- changes in 3.3.12-test6
  - Remove pydb in this directory. Use
    http://bashdb.sourceforge.net/pydb instead
  - fixed continue button for pydb
  - Start informing ddd that bash and pydb now have (or will have in the
    next release) "commands", and "display".
  - LynxOS support via Olli Savia
  - Add x86 theme for changing display expressions to x86 registers and
    flag-bits. Change Data/Memory examine behavior when used on Intel
    registers so that %%reg is the same as $reg.
    Contributed by Zarko Zivanov.
- changes in 3.3.12-test5
  - Had broken gdb support
  - Add vsllib/DEMOS into distribution
  - Changes Makefiles to make "distcheck" or VPATH, or building outside
    of source tree work better (It's still not complete though).
  - GNU Make, Python pydb and bashdb support improved:
  * command completion for bashdb and pydb (via gdb "complete")
  * possibly a better test for debuggers using "bashdb" (vs. "bash")
    and "remake" (vs. "make")
  * pydb and bashdb also now have built-in "cd" and "pwd" commands - use
    them.
  * deal with bogus file name <string> that comes up in
    tracebacks. Require a "run" to get pydb stack set correctly.
- changes in 3.3.12-test4
  - Minor bug fixes, mostly for Python support.
- changes in 3.3.12-test3
  - Extended python debugger support. Sort of a merge of pdb.py, ddd's old
    pydb.py and new things.
- changes in 3.3.12-test2
  - GNU Make (mdb) support.
- changes in 3.3.12-test
  - Fixed a bug parsing the gdb annotations -- this should improve
    the source code tracking accuracy.
  - Fixed a bug where gdb annotations were sent to the command window.
  - GNU Make debugger support
  - Fixes to Bash debugger (remove stack movement crashes, show
    breakpoints), better word parsing, e.g ${foo[@]}
  - Fixed a couple of warnings.
  - DDD now starts up much faster, and exits more cleanly (Doug Graham)
  - DDD now builds and runs on LynxOS (Olli Savia)
- splitted into two packages : ddd and ddd-doc
* Fri Sep  5 2008 bwalle@suse.de
- Fix UTF-8 warning to fit in a terminal with 80 characters wide.
- Don't print the warning if ~/.ddd/suse_no_utf8_warning exists.
* Sun Apr  6 2008 bwalle@suse.de
- Add ghostscript-library to BuildRequires.
* Sun Aug 26 2007 bwalle@suse.de
- execute with argv[0] == ddd so that X ressources with
  ddd.???? still apply (#304021)
* Tue May 29 2007 anosek@suse.cz
- added wrapper to workaround [#254472]
- updated README.SUSE
* Mon May 21 2007 anosek@suse.cz
- added README.SUSE explaning workaround for [#254472]
* Fri Mar 30 2007 dmueller@suse.de
- add ncurses-devel buildrequires
* Tue Feb 27 2007 dmueller@suse.de
- reduce buildrequires
* Mon Feb 26 2007 stbinner@suse.de
- fix build by including icon and .desktop into package
* Fri Jan 26 2007 ro@suse.de
- replace ghostscript-mini by ghostscript_any in BuildReq (#119914)
* Mon Aug  7 2006 mmarek@suse.cz
- fixed app-defaults file location
* Thu May 18 2006 ro@suse.de
- added freetype2-devel to BuildRequires
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Dec 16 2005 mmj@suse.de
- compile with -fno-strict-aliasing
* Tue Nov 29 2005 sbrabec@suse.cz
- Don't package icon already present in desktop-data-SuSE.
  Cleans rpm -V output.
* Wed May 11 2005 mmj@suse.de
- update to 3.3.11
* Fri Nov 26 2004 ltinkl@suse.cz
- update to 3.3.10
* Thu Nov 18 2004 mmj@suse.de
- Add icon file
- Don't remove buildroot before install
* Wed Oct 27 2004 ltinkl@suse.cz
- updated to 3.3.9
* Mon Jun 28 2004 ro@suse.de
- added libtiff to neededforbuild
* Sun Apr 25 2004 ro@suse.de
- use apache2
* Sat Jan 10 2004 adrian@suse.de
- build as user
* Wed Nov 19 2003 ro@suse.de
- use ghostscript-mini-package in neededforbuild
* Wed Nov 19 2003 ltinkl@suse.cz
- update to latest version 3.3.8
- fixed build
- recreate the HTML docu (make html) to get the JPG images
* Mon Sep  8 2003 mmj@suse.de
- Update to 3.3.7:
  o Ported to modern auto-tools, bison, flex and C++ STL
  o Bash debugging
  o Lots of bugfixes
* Sat Aug 16 2003 adrian@suse.de
- install desktop file from kappfinder
* Thu Apr 24 2003 ro@suse.de
- fix install_info --delete call and move from preun to postun
* Tue Feb 11 2003 mmj@suse.de
- Use %%install_info macro
* Mon Jan 27 2003 ro@suse.de
- make it build with gcc-3.3 (strstream.h)
* Mon Mar 18 2002 pmladek@suse.cz
- fixed installation of COPYING and NEWS files
* Fri Mar  8 2002 kukuk@suse.de
- Add /usr/share/ddd-%%{version} to filelist
* Tue Feb 12 2002 tcrhak@suse.cz
- added %%defattr to filelist
* Mon Jan 21 2002 schwab@suse.de
- Fix configure script for gcc 3 and use -Wno-deprecated.
* Thu Dec 20 2001 tcrhak@suse.cz
- update to version 3.3.1
* Mon Nov  5 2001 poeml@suse.de
- use apache-devel-packages macro in #neededforbuild
  (currently expands to apache, apache-devel, mm, expat)
* Mon Jun  4 2001 pblaha@suse.cz
- fix cast pointer on ia64
* Mon May  7 2001 mfabian@suse.de
- bzip2 source
* Wed Apr  4 2001 schwab@suse.de
- Add %%suse_update_config.
* Tue Mar 13 2001 pblaha@suse.cz
- update on new version 3.3
* Fri Feb 23 2001 ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Fri Dec  8 2000 schwab@suse.de
- Add %%suse_update_config.
- Fix compilation problem.
* Mon Nov 20 2000 pblaha@suse.cz
- support for openmotif
* Thu Sep 28 2000 ro@suse.de
- regenerate lex/bison sources
- removed patch to yacctoC.bison to make it compile again
* Mon May 22 2000 bubnikv@suse.cz
- moved doc to %%{_defaultdocdir}
- added buildroot
* Tue Feb 22 2000 fehr@suse.de
- changed to new version 3.2.1
- added html manual
* Mon Feb  7 2000 fehr@suse.de
- set build architecture correct
* Tue Feb  1 2000 fehr@suse.de
- add small change to circumvent compiler bug on axp
* Mon Jan 24 2000 fehr@suse.de
- changed to new version 3.2
* Mon Jan 10 2000 fehr@suse.de
- changed to new version 3.1.6
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Jul 26 1999 schwab@suse.de
- Define HAVE_STREAMS for linux again
- Handle getpt under HAVE_STREAMS
- Check isastream before using STREAMS ioctls
* Sun Jul 18 1999 kukuk@suse.de
- Don't define HAVE_STREAMS for linux
* Mon Jul 12 1999 uli@suse.de
- now builds with lesstif
* Tue Jul  6 1999 ro@suse.de
- cahnged to new version 3.1.4
* Tue Sep 22 1998 ro@suse.de
- ddd/TTYAgent.C: supply proper definition for ioctl for each libc
* Thu Jul  9 1998 fehr@suse.de
- Changed to version 3.0
* Wed Mar 11 1998 fehr@suse.de
- Changed to version 2.2.3
* Tue Dec  9 1997 ro@suse.de
- build static and dynamic version
* Mon Oct 13 1997 fehr@suse.de
- Changed to Version 2.1.1 of ddd
- prepare package for automatic build
* Mon Mar 24 1997 fehr@suse.de
- Changed to Version 2.0 of ddd
- Integrated the follwing patches to original 2.0 ddd:
  "dbx-comments-stripped, linux-userinfo, source-sash, xdb-list"
